Loading...
Searching...
No Matches
seqan3::dna15 Class Reference
Alphabet » Nucleotide

The 15 letter DNA alphabet, containing all IUPAC smybols minus the gap. More...

`#include <seqan3/alphabet/nucleotide/dna15.hpp>`

Inheritance diagram for seqan3::dna15:
[legend]

## Public Member Functions

Constructors, destructor and assignment
constexpr | dna15 () noexcept=default
| Defaulted.
constexpr | dna15 (dna15 const &) noexcept=default
| Defaulted.
constexpr | dna15 (dna15 &&) noexcept=default
| Defaulted.
constexpr dna15 & | operator= (dna15 const &) noexcept=default
| Defaulted.
constexpr dna15 & | operator= (dna15 &&) noexcept=default
| Defaulted.
| ~dna15 () noexcept=default
| Defaulted.
template<std::same_as< rna15 > t>
constexpr | dna15 (t const &r) noexcept
| Allow implicit construction from seqan3::rna15 of the same size.
Public Member Functions inherited from seqan3::nucleotide_base< dna15, 15 >
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr dna15 | complement () const noexcept
| Return the complement of the letter.
constexpr | nucleotide_base (other_nucl_type const &other) noexcept
| Allow explicit construction from any other nucleotide type and convert via the character representation.
Public Member Functions inherited from seqan3::alphabet_base< derived_type, size, char_t >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base const &) noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base &&) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base &&) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr derived_type & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr derived_type & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Related Symbols

(Note that these are not member symbols.)
using | dna15_vector = std::vector<dna15>
| Alias for a std::vector of seqan3::dna15.
Nucleotide literals
constexpr dna15 | operator""_dna15 (char const c) noexcept
| The seqan3::dna15 char literal.
constexpr dna15_vector | operator""_dna15 (char const *s, std::size_t n)
| The seqan3::dna15 string literal.

## Additional Inherited Members

Static Public Member Functions inherited from seqan3::nucleotide_base< dna15, 15 >
static constexpr bool | char_is_valid (char_type const c) noexcept
| Validate whether a character value has a one-to-one mapping to an alphabet value.
Static Public Attributes inherited from seqan3::nucleotide_base< dna15, 15 >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Static Public Attributes inherited from seqan3::alphabet_base< derived_type, size, char_t >
static constexpr detail::min_viable_uint_t< size > | alphabet_size = size
| The size of the alphabet, i.e. the number of different values it can take.
Protected Types inherited from seqan3::alphabet_base< derived_type, size, char_t >
using | char_type = std::conditional_t<std::same_as<char_t, void>, char, char_t>
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type = detail::min_viable_uint_t<size - 1>
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

The 15 letter DNA alphabet, containing all IUPAC smybols minus the gap.

Note that you can assign 'U' as a character to dna15 and it will silently be converted to 'T'.

Like most alphabets, this alphabet cannot be initialised directly from its character representation. Instead initialise/assign from the character literal 'A'_dna15 or use the function seqan3::dna15::assign_char().

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/nucleotide/dna15.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna15 letter{'A'_dna15};
letter.assign_char('C');
seqan3::debug_stream << letter << '\n'; // prints "C"
letter.assign_char('F'); // Unknown characters are implicitly converted to N.
seqan3::debug_stream << letter << '\n'; // prints "N"
}
seqan3::alphabet_base::assign_char
constexpr derived_type & assign_char(char_type const chr) noexcept
Assign from a character, implicitly converts invalid characters.
Definition alphabet_base.hpp:160
seqan3::dna15
The 15 letter DNA alphabet, containing all IUPAC smybols minus the gap.
Definition dna15.hpp:48
debug_stream.hpp
Provides seqan3::debug_stream and related types.
dna15.hpp
Provides seqan3::dna15, container aliases and string literals.
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
seqan3::literals
The SeqAn namespace for literals.

This entity is stable. Since version 3.1.

## Constructor & Destructor Documentation

## dna15()

template<std::same_as< rna15 > t>

seqan3::dna15::dna15 | ( | t const & | r | ) |

inline constexpr noexcept

Allow implicit construction from seqan3::rna15 of the same size.

Normally, we do not allow implicit conversion of single argument constructors, but in this case we make an exception, because seqan3::dna15 and seqan3::rna15 are interchangeable as they behave nearly the same (e.g. same ranks, same char to rank conversion).

#include <seqan3/alphabet/nucleotide/dna15.hpp>
#include <seqan3/alphabet/nucleotide/rna15.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna15 letter1 = 'C'_rna15; // implicitly converted
seqan3::dna15 letter2{};
letter2 = 'C'_rna15; // implicitly converted
}

seqan3::sequences (e.g. seqan3::dna15_vector) in general are not implicitly convertible and must be explicitly copied to be converted:

#include <vector>
#include <seqan3/alphabet/nucleotide/dna15.hpp>
#include <seqan3/alphabet/nucleotide/rna15.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna15_vector vector{'A'_rna15, 'C'_rna15, 'G'_rna15}; // (element-wise) implicit conversion
// but this won't work:
// seqan3::dna15_vector dna15_vector{"ACGT"_rna15};
// as a workaround you can use:
// side note: this would also work without the implicit conversion.
seqan3::rna15_vector rna15_vector = "ACGT"_rna15;
seqan3::dna15_vector dna15_vector{rna15_vector.begin(), rna15_vector.end()};
}

You can avoid this copy by using std::ranges::views:

#include <vector>
#include <seqan3/alphabet/nucleotide/dna15.hpp>
#include <seqan3/alphabet/nucleotide/rna15.hpp>
#include <seqan3/utility/views/convert.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna15_vector vector = "ACG"_dna15;
auto rna15_view = vector | seqan3::views::convert<seqan3::rna15>;
for (auto && chr : rna15_view) // converts lazily on-the-fly
{
static_assert(std::same_as<decltype(chr), seqan3::rna15 &&>);
}
}

This conversion constructor only allows converting seqan3::rna15 to seqan3::dna15. Other alphabets that inherit from seqan3::rna15 will not be implicitly convertible to seqan3::dna15.

#include <seqan3/alphabet/nucleotide/dna15.hpp>
#include <seqan3/alphabet/nucleotide/rna15.hpp>
struct my_dna15 : public seqan3::dna15
{
// using seqan3::dna15::dna15; // uncomment to import implicit conversion shown by letter1
};
struct my_rna15 : public seqan3::rna15
{};
int main()
{
using namespace seqan3::literals;
// my_dna15 letter1 = 'C'_rna15; // NO automatic implicit conversion!
// seqan3::dna15 letter2 = my_rna15{}; // seqan3::dna15 only allows implicit conversion from seqan3::rna15!
}

This entity is stable. Since version 3.1.

## Friends And Related Symbol Documentation

## dna15_vector

using dna15_vector = std::vector<dna15>

related

Alias for a std::vector of seqan3::dna15.

This entity is stable. Since version 3.1.

## operator""_dna15() [1/2]

dna15_vector operator""_dna15 | ( | char const * | s,
|  | std::size_t | n )

related

The seqan3::dna15 string literal.

Returns
  seqan3::dna15_vector

You can use this string literal to easily assign to dna15_vector:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
// generated from test/snippet/alphabet/nucleotide/@target_alphabet@_literal.cpp.in
#include <seqan3/alphabet/nucleotide/dna15.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna15_vector sequence1{"ACGTTA"_dna15};
seqan3::dna15_vector sequence2 = "ACGTTA"_dna15;
auto sequence3 = "ACGTTA"_dna15;
}

This entity is stable. Since version 3.1.

## operator""_dna15() [2/2]

dna15 operator""_dna15 | ( | char const | c | ) |

related

The seqan3::dna15 char literal.

Returns
  seqan3::dna15

You can use this char literal to assign a seqan3::dna15 character:

#include <seqan3/alphabet/nucleotide/dna15.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dna15 letter1{'A'_dna15};
auto letter2 = 'A'_dna15;
}

This entity is stable. Since version 3.1.

The documentation for this class was generated from the following file:

- dna15.hpp

Hide me